**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
** Report ZAF_BC_PRINT                                              **
**********************************************************************
** This program prints the AdobeForms form ZAF_BC_FORM              **
** This program must be used with the corresponding Adobe Forms     **
** Before running this program, the interface ZAF_BC_INTERFACE12    **
** and the form ZAF_BC_FORM must be installed.                      **
**********************************************************************
** Copyright (C) 1997-2016 Suchy MIPS                               **
** All rights reserved.                                             **
**********************************************************************
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstrae 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**  Internet: www.suchymips.de                                      **
**********************************************************************
**********************************************************************
REPORT  zaf_bc_print.


**********************************************************************
* DEKLARATIONEN
**********************************************************************
DATA: gv_if_type    TYPE fpinterfacetype,
      gv_fm_name    TYPE rs38l_fnam.

**********************************************************************
* SELECTION-SCREEN
**********************************************************************
SELECTION-SCREEN BEGIN OF BLOCK a WITH FRAME.
selection-screen begin of line.
selection-screen position 15.
PARAMETERS: p_fonam      TYPE fpname OBLIGATORY
                                     DEFAULT 'ZAF_BC_FORM'.
selection-screen comment 1(10) lv_text for field p_fonam.
selection-screen end of line.
SELECTION-SCREEN END OF BLOCK a.

**********************************************************************
* INITIALIZATION
**********************************************************************
initialization.
lv_text = 'Form'.
**********************************************************************
* START-OF-SELECTION
**********************************************************************
START-OF-SELECTION.

* Name des Funktionsbausteins holen ---------------------------------*
  PERFORM function_module_name USING    p_fonam
                               CHANGING gv_fm_name
                                        gv_if_type.

* Job ffnen --------------------------------------------------------*
  PERFORM job_open.

* Formular prozessieren ---------------------------------------------*
  PERFORM form_processing USING gv_fm_name.

* Job schlieen -----------------------------------------------------*
  PERFORM job_close.

*&-------------------------------------------------------------------*
*&      Form  FUNCTION_MODULE_NAME
*&-------------------------------------------------------------------*
FORM function_module_name  USING    p_fonam    TYPE fpname
                           CHANGING gv_fm_name TYPE rs38l_fnam
                                    gv_if_type TYPE fpinterfacetype.

* Initialisieren ----------------------------------------------------*
  CLEAR: gv_fm_name,
         gv_if_type.

* FuBa-Namen zum Formular holen -------------------------------------*
  CALL FUNCTION 'FP_FUNCTION_MODULE_NAME'
    EXPORTING
      i_name           = p_fonam
    IMPORTING
      e_funcname       = gv_fm_name
      e_interface_type = gv_if_type.

ENDFORM.                    " FUNCTION_MODULE_NAME
*&-------------------------------------------------------------------*
*&      Form  JOB_OPEN
*&-------------------------------------------------------------------*
FORM job_open.

* Deklarationen -----------------------------------------------------*
  DATA: ls_outparms    TYPE  sfpoutputparams.

* JOP_OPEN ----------------------------------------------------------*
  CALL FUNCTION 'FP_JOB_OPEN'
    CHANGING
      ie_outputparams = ls_outparms
    EXCEPTIONS
      cancel          = 1
      usage_error     = 2
      system_error    = 3
      internal_error  = 4
      OTHERS          = 5.
  IF sy-subrc <> 0.
    MESSAGE ID sy-msgid TYPE sy-msgty NUMBER sy-msgno
            WITH sy-msgv1 sy-msgv2 sy-msgv3 sy-msgv4.
  ENDIF.

ENDFORM.                    " JOB_OPEN
*&-------------------------------------------------------------------*
*&      Form  FORM_PROCESSING
*&-------------------------------------------------------------------*
FORM form_processing USING gv_fm_name  TYPE fpname.

* Deklarationen -----------------------------------------------------*
  DATA: ls_docparms     TYPE sfpdocparams.

* Formular prozessieren ---------------------------------------------*
  ls_docparms-langu   = sy-langu.
  CALL FUNCTION gv_fm_name
    EXPORTING
      /1bcdwb/docparams = ls_docparms
    EXCEPTIONS
      usage_error       = 1
      system_error      = 2
      internal_error    = 3
      OTHERS            = 4.

  IF sy-subrc <> 0.
    MESSAGE ID sy-msgid TYPE sy-msgty NUMBER sy-msgno
            WITH sy-msgv1 sy-msgv2 sy-msgv3 sy-msgv4.
  ENDIF.

ENDFORM.                    " FORM_PROCESSING
*&-------------------------------------------------------------------*
*&      Form  JOB_CLOSE
*&-------------------------------------------------------------------*
FORM job_close.

* Deklarationen -----------------------------------------------------*
  DATA: ls_result       TYPE sfpjoboutput.

* Job schlieen -----------------------------------------------------*
  CALL FUNCTION 'FP_JOB_CLOSE'
    IMPORTING
      e_result       = ls_result
    EXCEPTIONS
      usage_error    = 1
      system_error   = 2
      internal_error = 3
      OTHERS         = 4.
  IF sy-subrc <> 0.
    MESSAGE ID sy-msgid TYPE sy-msgty NUMBER sy-msgno
            WITH sy-msgv1 sy-msgv2 sy-msgv3 sy-msgv4.
  ENDIF.

ENDFORM.                    " JOB_CLOSE