**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
**   REPORT ZSF_BC_SETTINGS12                                       **
**********************************************************************
**                                                                  **
**                           RBarc+                                 **
**                       for SmartForms                             **
**                             V12                                  **
**                Copyright (C) 2007-2016 Suchy MIPS                **
**                      All rights reserved                         **
**                                                                  **
**********************************************************************
**  Serial No.: DEMO                                                **
**********************************************************************
**                     NOT FOR PRODUCTIVE USE!!!                    **
**********************************************************************
**                                                                  **
**  This is a part of RBarc+ version 12                             **
**                                                                  **
**  Defines Barcode properties, like height , width of bars etc.    **
**                                                                  **
**  The entry point is the FORM gen_barcode                         **
**                                                                  **
**  An unlimieted number of new bar code definitions may be added   **
**  to this report.                                                 **
**  Read comments in the code to get familiar with what is to do.   **
**  For detailed instructions refere to the manual                  **
**                                                                  **
**  Suchy MIPS shall not be liable for errors contained herein or   **
**  for incidental consequential damages in connection with use of  **
**  thisprogram.                                                    **
**                                                                  **
**  Copyright (C) 1997-2013 Suchy MIPS                              **
**  All rights reserved.                                            **
**                                                                  **
**  THIS PROGRAM SHELL BE INSTALLED IN THE TEST ENVIRONMENT         **
**  AND TESTED BEFORE USING ON THE PRODUCTIVE SYSTEM                **
**                                                                  **
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstraße 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**  Internet: www.suchymips.de                                      **
**********************************************************************
**********************************************************************
**  Released: 16.05.2013                                            **
**  Version:  12                                                    **
**  Release:  12.0.1                                                **
**********************************************************************
**********************************************************************
REPORT ZSF_BC_SETTINGS12.

DATA:  symbology(10), encoding_return(256), w_chksum,
       b TYPE i, bb TYPE i, bbb TYPE i, bbbb TYPE i,
       w TYPE i, ww TYPE i, www TYPE i, wwww TYPE i,
       barc_high TYPE f, xpos TYPE f, ypos TYPE f,
       rot TYPE i, sign TYPE i,
       mask(40), font(200), margin TYPE f,
       offset TYPE f, length TYPE f, unit(4),
       postyp TYPE i, encoding type string,
       barc_ident(10), graph_type(10) value '<0BMP>',
       checksum(5), res TYPE i, barc_name(256),
       bitmap_lines(31), smvar3(31),
       error_handling TYPE i, input_handling TYPE i,
       t1(70), t2(70), rt1(70), rt2(70),
       i1 TYPE i, i2 TYPE i, ri1 TYPE i, ri2 TYPE i,
       hde type i, the type i, tte type i,
       hdi type i, thi type i, tti type i, mtype value 'I',
       RecentCode, DataType.
TABLES: stxh.
data: begin of 128Table occurs 0,
               128value(12),
               DataType,
               RecentCode,
end of 128Table.

***********************************************************************
* \\\\\\\\\\\\\\\\\\\\\\\\\\   COMMENT   /////////////////////////////*
***********************************************************************
*      Form  GEN_BARCODE                                              *
***********************************************************************
*      -->ENCODING     C(40)                                           *
*      -->BARIDENT    C(10)                                           *
*      <--$SMBARNAME  STRING                                          *
*      <--$CHECKSUM   C(5)                                            *
***********************************************************************
* The form GEN_BARCODE must be performed from the Smartforms form.    *
* Appropriate Command nodes in the Smartforms form are required       *
*                                                                     *
* incoming (using) parameters:                                        *
* --------------------                                                *
* ENCODING   Encoding value.                                          *
*                                                                     *
* BARC_IDENT The bar code identification tag (max 10 char), like e.g. *
*            BARCODE01, BARCODE02...                                  *
*            This value must match the name of the FORM routine with  *
*            bar code settings, e.g. "FORM BARCODE01" in this report. *
*                                                                     *
* outgoing paramaters:                                                *
* --------------------                                                *
* BARC_NAME  returns the dynamically created name for the generated   *
*            bitmap                                                   *
*                                                                     *
* CHECKSUM   returns the calculated check sum                         *
*                                                                     *
* ENCODING_RETURN                                                     *
*            returns the value used for bar code processing           *
*            ENCODING_RETURN may be different then ENCODING if option *
*            for deleting leading '0' and/or SPACES has been selected *
*            and is usefull for printing HRT (humen readable text     *
*            near to the bar code                                     *
***********************************************************************

FORM GEN_BARCODE USING $ENCODING $BARC_IDENT
                 CHANGING $BARC_NAME $CHECKSUM $ENCODING_RETURN.
  encoding = $encoding.
  barc_ident = $barc_ident.

***********************************************************************
* \\\\\\\\\\\\\\\\\\\\\\\\\\   COMMENT   /////////////////////////////*
***********************************************************************
* PARAMETER DESCRIPTION  FOR GENERAL PROGRAM SETTINGS                 *
***********************************************************************
* error_handling: 0 - display all errors.                             *
*                     If a non fatal error occurs, a message appears  *
*                     and invalid value will be set to default.       *
*                     The program will continue bar code processing   *
*                     If a fatal error occurs, a message appears and  *
*                     a black rectangle will be generated.            *
*                                                                     *
*                 1 - display only fatal errors, else set defaults.   *
*                     If a non fata error occurs, the invalid value   *
*                     will be set to its default. No message appears. *
*                     The program will continue bar code processing   *
*                     If a fatal error occurs, a message appears.     *
*                     The programm will continue, but only a black    *
*                     rectangle will be generated.                    *
*                                                                     *
*                 2 - suppress all errors                             *
*                     No message appears and the program continues    *
*                     processing. If a non fatal error occurs, the    *
*                     invalid value will be set to its default.       *
*                     If a fatal error occurs, the program will       *
*                     process a black rectangle.                      *
*                                                                     *
*                 Following parameters may cause a NON FATAL error and*
*                 can be set tothe default automatically:             *
*                                                                     *
*                     RES, default = 150.                             *
*                     XPOS, defealut = 0.                             *
*                     YPOS, default  = 0.                             *
*                     HIGH, default  = 10 mm                          *
*                     MARGIN, default  = 0.                           *
*                     OFFSET, default  = 0.                           *
*                     ROT, default  = 0.                              *
*                     UNIT, default = 'mm'                            *
*                     SIGN, default  = 0.                             *
*                     B, default  = 10,                               *
*                     BB, default = 2xB,                              *
*                     BBB, default = 3xB                              *
*                     BBBB, default = 4xB                             *
*                     W, default = B                                  *
*                     WW, default = 2xB                               *
*                     WWW, default = 3xB                              *
*                     WWWW, default  = 4xB                            *
*                                                                     *
*                 Following parameters may cause a FATAL error and    *
*                 prevent the program from printing a proper bar code.*
*                 On its place a BLACK RECTANGLE will be printed:     *
*                                                                     *
*                     ENCODING  -  if empty or invalid                *
*                     SYMBOLOGY -  if unknown                         *
***********************************************************************
*  input_handling: 0 - don't change the input value                   *
*                  1 - delete leading '0'                             *
*                  2 - delete leading spaces                          *
*                  9 - delete leading '0' and leading spaces          *
*             special options:                                        *
*                  add 10 to input_handling to delete invalic         *
*                  characters from the encoding string.               *
*                                                                     *
***********************************************************************
* RES:            Bar code bitmap resolution. Usefull values are:     *
*                 75, 150, 300... but also other values like 200      *
*                 or even 202 are allowed.                            *
*          NOTE:  The defined bitmap resolution MUST match with       *
*                 the graphic resolution selected in the form and MUST*
*                 be supported by your printig device, otherwise the  *
*                 printed size will not achieve your expectations     *
***********************************************************************

  error_handling = 0.
  input_handling = 0.
  res = 150.

***********************************************************************
* \\\\\\\\\\\\\\\\\\\\\\\\\\   COMMENT   /////////////////////////////*
***********************************************************************
* Setting bar code properties, like symbologie, heigh...              *
* To define a new bar code insert an appropriate FORM into this       *
* report (e.g. FORM BARCODE17). Remember, that the name of the FORM   *
* must be identical with the BARIDENT parameter from the              *
* Smartforms form                                                     *
* An unlimieted number of new bar code definitions may be added       *
* in this report. To expirience more, search for -SETTINGS-           *
* (with hypens at the left and right site of SETTINGS) in this report *
***********************************************************************
  translate barc_ident to upper case.
  PERFORM (barc_ident) IN PROGRAM zsf_bc_settings12.

***********************************************************************
* \\\\\\\\\\\\\\\\\\\\\\\\\\   COMMENT   /////////////////////////////*
***********************************************************************
* Start to generate the bar code image.                               *
***********************************************************************
  PERFORM gen_barc.
  $barc_name = barc_name.
  $checksum = checksum.
  $encoding_return = encoding_return.
ENDFORM.                    "GEN_BARCODE

***********************************************************************
* \\\\\\\\\\\\\\\\\\\\\\\\\\   COMMENT   /////////////////////////////*
***********************************************************************
*                      BAR CODE -SETTINGS-                            *
***********************************************************************
* Bar code properties (like height, widht...) shall be defined in     *
* the section below. Use a separate FORM-routine for each bar code    *
* The parameter to be defined are listet below:                       *
***********************************************************************
***********************************************************************
* SYMBOLOGY     The bar code symbology which shall be generated       *
*               supportet values are listed below:                    *
*                                                                     *
* VALUE:        SYMBOLOGY:                                            *
* --------------------------------------------------------------------*
* '2o5interl'	= 2 of 5 interleaved                                    *
* '2o5indust'	= 2 of 5 industrial                                     *
* '2o5matrix'	= 2 of 5 matrix                                         *
* '2o5gp'	    = 2 of 5 German postal bar code (11 and 13)             *
*                                                                     *
* '39'        = Code 39                                               *
* '39e'	      = Code 39 extended                                      *
* '39f'	      = French postal 39 A/R                                  *
* '39d'	      = Danish 39 PTT                                         *
*                                                                     *
* '93'        = Code 93                                               *
* '93e'	      = Code 93 extended                                      *
*                                                                     *
* 'codabarXY'	= Codabar with corresponding START and STOP symbol.     *
*               There are 4 START/STOP Symbols in codabar:            *
*               A, B, C and D.                                        *
*               They can be used in any order, up to user.            *
*               Set the argument bar code e.g to #codabarCA#          *
*               to use #C# for START and #A# for STOP.                *
*               There are 16 combinations of START/STOP symbols       *
*               (AA, AB, AC, AD...DA, DB, DC, DD)                     *
*	                                                                    *
* '128-A'	      = Code 128 A                                          *
* '128-B'	      = Code 128 B                                          *
* '128-C'	      = Code 128 C                                          *
* '128FREE'     = Free editable Code 128 supporting function codes    *
* 'E.A.N.128'	  = Code EAN 128                                        *
* '128auto'     = Code 128 Autoswitch                                 *
* 'ucc-128'     = Code UCC-128                                        *
*                                                                     *
* '128HIBC'     = HIBC one line code based on code 128 for supplier   *
*                 and provider label. Suppliers and providers data    *
*                 must be separeted by '/'. The '+' at the beginning  *
*                 can but  must not be send because it will be        *
*                 generated  automatically. The HIBC check sum will   *
*                 be calculated  automatically.                       *
*                                                                     *
* '128HIBCP'   = HIBC one line code based on code 128 for provider    *
*               label only. The '+' will not be added automatically.  *
*               The HIBC check sum will be calculated automatically.  *
*                                                                     *
*                                                                     *
* 'MSI1'       = MSI (without check sum)                              *
* 'MSI2'       = MSI + CHK10                                          *
* 'MSI3'       = MSI+ CHK10+CHK10                                     *
* 'MSI4'       = MSI+CHK11+CHK10                                      *
*                                                                     *
* 'EAN-13'     = EAN/JAN 13                                           *
* 'EAN-13+2'   = EAN/JAN 13+2                                         *
* 'EAN-13+5'   = EAN/JAN 13+5                                         *
* 'EAN-8'      = EAN/JAN 8                                            *
* 'EAN-8+2'	   = EAN/JAN 8+2                                          *
* 'EAN-8+5'	   = EAN/JAN 8+5                                          *
*                                                                     *
* 'UPC-A'      = UPC-A                                                *
* 'UPC-A+2'	   = UPC-A+2                                              *
* 'UPC-A+5'	   = UPC-A+5                                              *
* 'UPC-E'      = UPC-E                                                *
* 'UPC-E+2'    = UPC-E+2                                              *
* 'UPC-E+5'    = UPC-E+5                                              *
***********************************************************************
* W_CHKSUM                                                            *
* generates the check sum if set to 'X'.                              *
* Note: some bar code symbologies, like code 128 require a check sum  *
* In this case this parameter will be ignored                         *
* and the check sum generated automatically                           *
* Following bar code symbologies may be generated with OR without     *
* check sum:                                                          *
* Code 39, Code 39 extended, code 2 of 5 matrix, code 2 of 5 interl.  *
***********************************************************************
* B                                                                   *
* The width of the thinnest bar in a bar code symbol.                 *
* Other bars and spaces will be calculated automatically.             *
* Refere to the manual for more information, if you wish to set other *
* bars and/or spaces manualy                                          *
***********************************************************************
* UNIT                                                                *
* the measure unit for BARC_HIGH, MARGIN and OFFSET                   *
* Valid values are: 'mm', 'cm' and 'inch'                             *
***********************************************************************
* BARC_HIGH                                                           *
* Bar code height in defined UNITs                                    *
***********************************************************************
* MARGIN                                                              *
* The height of the insection for Human Readable Text below the       *
* bar code in defined in UNITs                                        *
***********************************************************************
* OFFSET                                                              *
* Only required if MARGING is defined.                                *
* Defines, where the insection shall begin. The left and right        *
* distance of the insection to the border of the bar code will        *
* allways be the same. To be defined in UNITs                         *
***********************************************************************
* ROT                                                                 *
* Bar code rotation. Valid values are 0, 90, 180 and 270              *
***********************************************************************

***********************************************************************
*                      BEGIN OF BAR CODE 1 SETTINGS                   *
***********************************************************************
FORM barcode01.
  symbology = '39'.
  w_chksum = 'X'.
  b = 12.
  barc_high = '13'.
  unit = 'mm'.
  margin = '0.00'.
  offset = '0.00'.
  rot = 0.
ENDFORM.                                                    "BARCODE01
***********************************************************************
*                      END OF BAR CODE 1 SETTINGS                     *
***********************************************************************

***********************************************************************
*                      BEGIN OF BAR CODE 2 SETTINGS                   *
***********************************************************************
FORM barcode02.
  symbology = '2o5interl'.
  symbology = '39'.
  w_chksum = ''.
  b = 18.
  barc_high = '22.00'.
  unit = 'mm'.
  margin = '3.00'.
  offset = '30.00'.
  rot = 0.
ENDFORM.                                                    "BARCODE02
***********************************************************************
*                        END OF BAR CODE 2 SETTINGS                   *
***********************************************************************

***********************************************************************
*                      BEGIN OF BAR CODE 3 SETTINGS                   *
***********************************************************************
FORM barcode03.
  symbology = '128Aauto'.
  symbology = '39'.
  w_chksum = ''.
  b = 15.
  barc_high = '18'.
  unit = 'mm'.
  margin = '0.00'.
  offset = '0.00'.
  rot = 90.
ENDFORM.                                                    "BARCODE03
***********************************************************************
*                      END OF BAR CODE 3 SETTINGS                     *
***********************************************************************

***********************************************************************
*                      BEGIN OF BAR CODE 4 SETTINGS                   *
***********************************************************************
FORM barcode04.
  symbology = 'EAN-13'.
  symbology = '39'.
  w_chksum = ''.
  b = 15.
  barc_high = '18'.
  unit = 'mm'.
  margin = '0.00'.
  offset = '0.00'.
  rot = 270.
ENDFORM.                                                    "BARCODE04
***********************************************************************
*                      END OF BAR CODE 4 SETTINGS                     *
***********************************************************************

***********************************************************************
*                      BEGIN OF BAR CODE 5 SETTINGS                   *
***********************************************************************
FORM barcode05.
  symbology = 'EAN-13+5'.
  w_chksum = 'X'.
  b = 12.
  barc_high = '30'.
  unit = 'mm'.
  margin = '3.20'.
  offset = '0.00'. "not used with EAN/UPC
  rot = 0.
ENDFORM.                                                    "BARCODE05
***********************************************************************
*                      END OF BAR CODE 5 SETTINGS                     *
***********************************************************************
***********************************************************************
*                      BEGIN OF BAR CODE 6 SETTINGS                   *
***********************************************************************
FORM barcode06.
  symbology = '128free'.
  w_chksum = 'X'.
  b = 8.
  barc_high = '13'.
  unit = 'mm'.
  margin = '0.00'.
  offset = '0.00'.
  rot = 0.
********************************************************************
* Explanation to barcode 06: 128FREE.
********************************************************************
* Encoding Subsets
* Subset A:
* ASCII 32 - 95,
* [NUL],[SOH],[STX],[ETX],[EOT],[ENQ],[ACK],[BEL],[BS],[HT],
* [LF],[VT],[FF],[CR],[SO],[SI],[DLE],[DC1],[DC2],[DC3],
* [DC4],[NAK],[SYN],[ETB],[CAN],[EM],[SUB],[ESC],[FS],[GS],
* [RS],[US],[FNC3],[FNC2],[SHIFT],[CODE C],[CODE B],[FNC4],[FNC1],
********************************************************************
* Subset B:
* ASCII 32 - 126
* [DEL],[FNC3],[FNC2],[SHIFT],[CODE C],[FNC4],[CODE A],[FNC1],
********************************************************************
* Subset C:
* digit pairs 00 - 99
* [CODE B], [CODE A], [FNC1]
********************************************************************
* Start function Codes (only at the beginning of the barcode)
* [START CODE A],[START CODE B],[START CODE C]
********************************************************************
* NOTE: 2 Data Types are supported:
* - function codes (like "START CODE A" -> DataType 'F'
* - Text encoding -> DataType 'T'
*
* Use the form collect_128 to collect all encoding data including
* function codes and text.
*
* Only ONE function code may be added at one time. For each function
* code the form "collect_128" has to be performed separately
*
* A continous text encoding stream my be performed at once using
* the form "collect_128"
********************************************************************
* Example of data encoding for 128 free styled.
* The ecoding value is:
* [START B][FNC1]241 G1A[FNC1]10 1274[FNC1][CODE C]3705
* Note: the check sum and STOP symbol will be added automatically
* All spezified symbols for all Subsets (A,B and C) are supported.

encoding = 'Start Code B'.
DataType = 'F'.
perform collect_128 using encoding DataType.
*
encoding = 'FNC1'.
DataType = 'F'.
perform collect_128 using encoding DataType.
*
encoding = '241 G1A'.
DataType = 'T'.
perform collect_128 using encoding DataType.
*
encoding = 'FNC1'.
DataType = 'F'.
perform collect_128 using encoding DataType.

encoding = '10 1274'.
DataType = 'T'.
perform collect_128 using encoding DataType.
*
encoding = 'FNC1'.
DataType = 'F'.
perform collect_128 using encoding DataType.
*
encoding = 'Code C'.
DataType = 'F'.
perform collect_128 using encoding DataType.
*
encoding = '3705'.
DataType = 'T'.
perform collect_128 using encoding DataType.

ENDFORM.                                                    "BARCODE06
***********************************************************************
*                      END OF BAR CODE 6 SETTINGS                     *
***********************************************************************

***********************************************************************
***********************************************************************
*          USER SHALL NOT MAKE ANY CHANGES BELOW THIS LINE            *
***********************************************************************
***********************************************************************

***********************************************************************
*       DELETE BARCODE                                                *
* This form delets the bitmap created by RBarc+                       *
* it should be performed from the Smartforms form                     *
* immediatelly after including the bar code PCL-Bitmpa into the form  *
* USE ONLY WITH PCL BITMAPS                                           *
***********************************************************************
FORM DEL_BARC_BMP USING SMVAR_N.

  Data:
  i_name like stxbitmaps-tdname,
  i_object like stxbitmaps-tdobject,
  i_id like stxbitmaps-tdid,
  i_btype like  stxbitmaps-tdbtype,
  error like sy-subrc.

  I_NAME = SMVAR_N.


  call function 'SAPSCRIPT_DELETE_GRAPHIC_BDS'
    EXPORTING
      i_object      = 'GRAPHICS'
      i_name        = i_name
      i_id          = 'BMAP'
      i_btype       = 'BMON'
      dialog        = ''
    EXCEPTIONS
      delete_failed = 1
      not_found     = 2
      canceled      = 3
      others        = 4.

  error = sy-subrc.
ENDFORM.                    "DEL_BARC_BMP



***********************************************************************
*      BAR CODE PROCESSING                                            *
***********************************************************************
*       Generates the barcode with defined properties                 *
***********************************************************************
FORM GEN_BARC.

  PERFORM print_barcode
   USING
     symbology encoding w_chksum
     b bb bbb bbbb
     w ww www wwww
     barc_high xpos ypos  rot sign
     mask font margin offset length
     unit barc_ident postyp 0 0
     graph_type res
     t1 t2 i1 i2
   CHANGING
     barc_name bitmap_lines
     smvar3 checksum
     encoding_return mtype
     rt1 rt2 ri1 ri2.
ENDFORM.                    "PRINTBC
INCLUDE ZSF_12.